"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var explore_editor_1 = __importDefault(require("explore-editor"));
var plugins_1 = __importDefault(require("explore-editor/lib/plugins"));
require("explore-editor/lib/assets/css/editor.css");
require("explore-editor/lib/assets/css/editor-contents.css");
var getLanguage_1 = __importDefault(require("./getLanguage"));
var ReactEditor = function (props) {
    var editor = (0, react_1.useRef)(null);
    var ExploreEditorTextareaId = props.textareaId || "textarea-" + Math.floor(Math.random() * 999);
    var customPlugins = props.customPlugins, lang = props.lang, onChange = props.onChange, setContents = props.setContents;
    var appendCustomPlugins = (0, react_1.useCallback)(function () {
        if (customPlugins && Array.isArray(customPlugins) && customPlugins.length) {
            customPlugins.forEach(function (customPlugin) {
                plugins_1.default[customPlugin.name] = customPlugin;
            });
        }
        return plugins_1.default;
    }, [customPlugins]);
    (0, react_1.useEffect)(function () {
        appendCustomPlugins();
        editor.current = explore_editor_1.default.create(editor.current, __assign(__assign({}, props), { lang: (0, getLanguage_1.default)(lang), plugins: plugins_1.default }));
        if (onChange) {
            editor.current.onChange = onChange;
        }
        if (setContents) {
            editor.current.setContents(setContents);
        }
        return function () {
            if (editor.current) {
                editor.current.destroy();
            }
        };
    }, [appendCustomPlugins, props, onChange, setContents, lang]);
    return react_1.default.createElement("textarea", { ref: editor, id: ExploreEditorTextareaId });
};
exports.default = ReactEditor;
